#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.

proc auto_upd {} {
  global canvas	dialog sysinfo

  busy_cursor

## Bring up the standard Dialog box ##
  set dialog(autoUpdate) ".auto_upd"
  set dbox [popupDialogBox $dialog(autoUpdate) "Automatic Update of Data"]
  set activeWindow($dialog(autoUpdate) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{ {stop "stop updating"} {rstart "start updating"} {cont "close window"} {help help}}} x 2m 18 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdStop   [lindex $cmdButtons 1]
  set cmdRstart [lindex $cmdButtons 2]
  set cmdCont   [lindex $cmdButtons 3]
  set cmdHelp   [lindex $cmdButtons 4]

  $cmdRstart configure -command {
    if { [string compare $sysinfo(autoUpdateMins) ""] == 0 } {
      popupInfoBox $dialog(autoUpdate) "Please specify the minutes interval"
      return
    }
    incr sysinfo(DATA_UPDATE_SEQ)
    after [expr round($sysinfo(autoUpdateMins) * 60000)] data_auto_update \
			$sysinfo(DATA_UPDATE_SEQ)
    popupInfoBox $dialog(autoUpdate) \
      "Data auto updating will start in $sysinfo(autoUpdateMins) mins."
    if { [string compare $sysinfo(cmdButtonUpdAuto) ""] != 0 } {
	$sysinfo(cmdButtonUpdAuto) configure \
			-background $canvas(bigActiveColor)
    }
    set sysinfo(autoUpdate) 1
  }
  $cmdStop configure -command {
    incr sysinfo(DATA_UPDATE_SEQ) 
    popupInfoBox $dialog(autoUpdate) "Data auto updating stopped."
    if { [string compare $sysinfo(cmdButtonUpdAuto) ""] != 0 } {
	$sysinfo(cmdButtonUpdAuto) configure -background $canvas(bigBg)
    }
    set sysinfo(autoUpdate) 0
  }
  $cmdCont configure -command {
    destroy $dialog(autoUpdate)
  }
  $cmdHelp configure -command {xpbs_help auto_update $dialog(autoUpdate)}

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.u
  frame $dbox_top.u.mins

  label $dbox_top.u.l -text "mins"
  set spinBox [buildSpinbox $dbox_top.u.mins 4 1-9999 sysinfo(autoUpdateMins) \
		"" "Update Data every" left $sysinfo(autoUpdateMins)]

  set minsFrame  [lindex $spinBox 0]
  set minsEntry  [lindex $spinBox 1]

  register_default_action $minsEntry $cmdCont

  pack $dbox_top.u.mins $dbox_top.u.l -anchor nw -side left
  pack $dbox_top.header $dbox_top.u $dbox_top.footer -padx 5m


  register_default_action $dialog(autoUpdate) $cmdCont

  tkwait visibility $dialog(autoUpdate)
  remove_busy_cursor
  catch {tkwait window $dialog(autoUpdate)}
  set activeWindow($dialog(autoUpdate) 0
}
proc data_auto_update {update_seq} {
  global sysinfo 

  if { $update_seq != $sysinfo(DATA_UPDATE_SEQ) } {
    InfoBox_sendmsg "data_auto_update: updating stopped." 1
    return
  }
  after [expr round($sysinfo(autoUpdateMins) * 60000)] \
			[list data_auto_update $update_seq]
  systemPopulateNodesWithInfo $sysinfo(systemFrame)
}
